(* Parsing strings to sort tables *)

type functorExp =
    | Choice of functorExp * functorExp
    | Fusion of functorExp * functorExp
    | Composition of functorExp * functorExp
    | Unary of string list (* a nonempty list of identifiers *)

exception FunctorParsingFailed of string

val stringFromFunctorExp : functorExp -> string
val functorExpFromString : string -> functorExp

val sortTableFromFunctorExp : functorExp -> CoAlgReasoner.sortTable

val sortTableFromString : string -> CoAlgReasoner.sortTable

val stringFromSortTable : CoAlgReasoner.sortTable -> string


(* vim: set et sw=2 sts=2 ts=8 : *)
