type ('a, 'b) hash_consed =
    private { node : 'a; hkey : int; tag : int; fml : 'b; mutable neg : ('a, 'b) hash_consed }

module type HashedTyped =
  sig
    type nde
    type fml
    val equal : nde -> nde -> bool
    val hash : nde -> int
    val toFml : nde -> fml
    val negNde : nde -> nde
  end

module type S =
  sig
    type t
    type nde
    type fml
    val create : ?size:int -> bool -> t
    val hashcons : t -> nde -> (nde, fml) hash_consed
    val length : t -> int
    val iter : ((nde, fml) hash_consed -> unit) -> t -> unit
    val fold : ('a -> (nde, fml) hash_consed -> 'a) -> 'a -> t -> 'a
  end

module Make(H : HashedTyped) : (S with type nde = H.nde and type fml = H.fml)

(* vim: set et sw=2 sts=2 ts=8 : *)
